## pillow 7.0.0

=== Makefile ===
# https://www.gnu.org/software/make/manual/html_node/Phony-Targets.html
.PHONY: clean coverage doc docserve help inplace install install-req release-test sdist test upload upload-test
.DEFAULT_GOAL := release-test

clean:
	python3 setup.py clean
	rm src/PIL/*.so || true
	rm -r build || true
	find . -name __pycache__ | xargs rm -r || true

BRANCHES=`git branch -a | grep -v HEAD | grep -v master | grep remote`
co:
	-for i in $(BRANCHES) ; do \
        git checkout -t $$i ; \
    done

coverage:
	python3 selftest.py
	python3 setup.py test
	rm -r htmlcov || true
	coverage report

doc:
	$(MAKE) -C docs html

doccheck:
	$(MAKE) -C docs html
# Don't make our tests rely on the links in the docs being up every single build.
# We don't control them.  But do check, and update them to the target of their redirects.
	$(MAKE) -C docs linkcheck || true

docserve:
	cd docs/_build/html && python3 -mSimpleHTTPServer 2> /dev/null&

help:
	@echo "Welcome to Pillow development. Please use \`make <target>\` where <target> is one of"
	@echo "  clean              remove build products"
	@echo "  coverage           run coverage test (in progress)"
	@echo "  doc                make html docs"
	@echo "  docserve           run an http server on the docs directory"
	@echo "  html               to make standalone HTML files"
	@echo "  inplace            make inplace extension"
	@echo "  install            make and install"
	@echo "  install-coverage   make and install with C coverage"
	@echo "  install-req        install documentation and test dependencies"
	@echo "  install-venv       install in virtualenv"
	@echo "  release-test       run code and package tests before release"
	@echo "  test               run tests on installed pillow"
	@echo "  upload             build and upload sdists to PyPI"
	@echo "  upload-test        build and upload sdists to test.pythonpackages.com"

inplace: clean
	python3 setup.py develop build_ext --inplace

install:
	python3 setup.py install
	python3 selftest.py

install-coverage:
	CFLAGS="-coverage" python3 setup.py build_ext install
	python3 selftest.py

debug:
# make a debug version if we don't have a -dbg python. Leaves in symbols
# for our stuff, kills optimization, and redirects to dev null so we
# see any build failures.
	make clean > /dev/null
	CFLAGS='-g -O0' python3 setup.py build_ext install > /dev/null

install-req:
	pip install -r requirements.txt

install-venv:
	virtualenv .
	bin/pip install -r requirements.txt

release-test:
	$(MAKE) install-req
	python3 setup.py develop
	python3 selftest.py
	python3 -m pytest Tests
	python3 setup.py install
	python3 -m pytest -qq
	check-manifest
	pyroma .
	viewdoc

sdist:
	/opt/local/bin/python3.5 setup.py sdist --format=gztar

test:
	pytest -qq

# https://docs.python.org/3/distutils/packageindex.html#the-pypirc-file
upload-test:
#       [test]
#       username:
#       password:
#       repository = http://test.pythonpackages.com
	python3 setup.py sdist --format=gztar upload -r test

upload:
	python3 setup.py sdist --format=gztar upload

readme:
	viewdoc

=== requirements.txt ===
# Development, documentation & testing requirements.
black; python_version >= '3.6'
check-manifest
coverage
coveralls
jarn.viewdoc
olefile
pycodestyle
pyflakes
pyroma
pytest
pytest-cov
sphinx-rtd-theme

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html -W --keep-going $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PillowPILfork.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PillowPILfork.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/PillowPILfork"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/PillowPILfork"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

livehtml: html
	livereload $(BUILDDIR)/html -p 33233

serve:
	cd $(BUILDDIR)/html; python -m SimpleHTTPServer

=== debian/changelog ===
pillow (7.0.0-4ubuntu0.9) focal-security; urgency=medium

  * SECURITY UPDATE: Buffer overflow in imagingcms.c
    - debian/patches/CVE-2024-28219.patch: Use strncpy
    to avoid buffer overflow
    - CVE-2024-28219

 -- Nick Galanis <nick.galanis@canonical.com>  Fri, 12 Apr 2024 15:21:40 +0100

pillow (7.0.0-4ubuntu0.8) focal-security; urgency=medium

  * SECURITY UPDATE: DoS in ImageFont via large textlength
    - debian/patches/CVE-2023-44271.patch: added a maximum string length in
      Tests/test_imagefont.py, docs/reference/ImageFont.rst,
      src/PIL/ImageFont.py.
    - CVE-2023-44271
  * SECURITY UPDATE: PIL.ImageMath.eval Arbitrary Code Execution
    - debian/patches/CVE-2023-50447-1.patch: don't allow __ or builtins in
      env dictionarys for ImageMath.eval in src/PIL/ImageMath.py.
    - debian/patches/CVE-2023-50447-2.patch: allow ops in
      Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - debian/patches/CVE-2023-50447-3.patch: include further builtins in
      Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - CVE-2023-50447

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 25 Jan 2024 12:48:42 -0500

pillow (7.0.0-4ubuntu0.7) focal-security; urgency=medium

  * SECURITY UPDATE: arbitrary file deletion
    - debian/patches/CVE-2022-24303.patch: No longer remove temporary images
      manually in src/PIL/ImageShow.py.
    - CVE-2022-24303
  * SECURITY UPDATE: gif decompression bomb issue
    - debian/patches/CVE-2022-45198.patch: Added GIF decompression bomb check
      in src/PIL/GifImagePlugin.py.
    - CVE-2022-45198

 -- Fabian Toepfer <fabian.toepfer@canonical.com>  Mon, 12 Dec 2022 21:23:40 +0100

pillow (7.0.0-4ubuntu0.6) focal-security; urgency=medium

  * SECURITY UPDATE: incomplete fix for CVE-2022-22817
    - debian/patches/CVE-2022-22817-2.patch: restrict builtins within
      lambdas for ImageMath.eval in Tests/test_imagemath.py,
      src/PIL/ImageMath.py.
    - CVE-2022-22817

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Oct 2022 11:28:59 -0400

pillow (7.0.0-4ubuntu0.5) focal-security; urgency=medium

  * SECURITY UPDATE: regular expression DoS
    - debian/patches/CVE-2021-23437.patch: raise ValueError if color
      specifier is too long in Tests/test_imagecolor.py,
      src/PIL/ImageColor.py.
    - CVE-2021-23437
  * SECURITY UPDATE: Dos via buffer overflow
    - debian/patches/CVE-2021-34552.patch: limit sprintf modes to 10
      characters in src/libImaging/Convert.c.
    - CVE-2021-34552
  * SECURITY UPDATE: improper initialization
    - debian/patches/CVE-2022-22815.patch: initialize coordinates to zero
      in src/path.c.
    - CVE-2022-22815
  * SECURITY UPDATE: buffer over-read during initialization
    - debian/patches/CVE-2022-22816.patch: handle case where path count is
      zero in src/path.c.
    - CVE-2022-22816
  * SECURITY UPDATE: evaluation of arbitrary expressions
    - debian/patches/CVE-2022-22817.patch: restrict builtins for
      ImageMath.eval in Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - CVE-2022-22817

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Jan 2022 13:05:20 -0500

pillow (7.0.0-4ubuntu0.4) focal-security; urgency=medium

  * SECURITY UPDATE: OOB read in Jpeg2KDecode
    - debian/patches/CVE-2021-25287_8.patch: handle different widths for
      each band in src/libImaging/Jpeg2KDecode.c.
    - CVE-2021-25287
    - CVE-2021-25288
  * SECURITY UPDATE: DOS in PsdImagePlugin
    - debian/patches/CVE-2021-28675.patch: sanity check the number of
      input layers in Tests/test_decompression_bomb.py,
      Tests/test_file_apng.py, Tests/test_file_blp.py,
      Tests/test_file_tiff.py, src/PIL/ImageFile.py,
      src/PIL/PsdImagePlugin.py.
    - CVE-2021-28675
  * SECURITY UPDATE: FLI DOS
    - debian/patches/CVE-2021-28676.patch: check the block advance in
      src/libImaging/FliDecode.c.
    - CVE-2021-28676
  * SECURITY UPDATE: EPS DOS on _open
    - debian/patches/CVE-2021-28677.patch: properly handle line endings in
      src/PIL/EpsImagePlugin.py.
    - CVE-2021-28677
  * SECURITY UPDATE: BLP DOS
    - debian/patches/CVE-2021-28678.patch: check that reads return data in
      src/PIL/BlpImagePlugin.py.
    - CVE-2021-28678

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 18 May 2021 07:19:28 -0400

pillow (7.0.0-4ubuntu0.3) focal-security; urgency=medium

  * SECURITY UPDATE: insufficient fix for CVE-2020-35654
    - debian/patches/CVE-2021-25289.patch: improve return code check in
      src/libImaging/TiffDecode.c.
    - CVE-2021-25289
  * SECURITY UPDATE: negative-offset memcpy with an invalid size
    - debian/patches/CVE-2021-25290.patch: add extra check to
      src/libImaging/TiffDecode.c.
    - CVE-2021-25290
  * SECURITY UPDATE: invalid tile boundaries could lead to an OOB Read
    - debian/patches/CVE-2021-25291.patch: check tile validity in
      src/libImaging/TiffDecode.c.
    - CVE-2021-25291
  * SECURITY UPDATE: DoS via backtrack regex
    - debian/patches/CVE-2021-25292.patch: use more specific regex in
      src/PIL/PdfParser.py.
    - CVE-2021-25292
  * SECURITY UPDATE: Out of Bounds Read
    - debian/patches/CVE-2021-25293.patch: add more checks to
      src/libImaging/SgiRleDecode.c.
    - CVE-2021-25293
  * SECURITY UPDATE: DoS via invalid reported size
    - debian/patches/CVE-2021-2792x.patch: check reported sizes in
      src/PIL/BlpImagePlugin.py, src/PIL/IcnsImagePlugin.py,
      src/PIL/IcoImagePlugin.py.
    - CVE-2021-27921
    - CVE-2021-27922
    - CVE-2021-27923

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 10 Mar 2021 12:48:44 -0500

pillow (7.0.0-4ubuntu0.2) focal-security; urgency=medium

  * SECURITY UPDATE: buffer over-read via PCX file
    - debian/patches/CVE-2020-35653.patch: don't trust the image to specify
      a buffer size in src/PIL/PcxImagePlugin.py.
    - CVE-2020-35653
  * SECURITY UPDATE: heap overflow via YCbCr files
    - debian/patches/CVE-2020-35654-1.patch: fix tiff comparison warnings


=== debian/control ===
Source: pillow
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), tk-dev, dpkg-dev (>= 1.16.1~),
  dh-python,
  python2,
  python3-all-dev, python3-all-dbg, python3-setuptools,
  python3-tk, python3-tk-dbg,
  python3-pytest,
  python3-olefile,
  python3-cffi,
  libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
  libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
  libimagequant-dev,
Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
Standards-Version: 4.5.0
Homepage: http://python-pillow.github.io/
XS-Testsuite: autopkgtest

Package: python3-pil
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, mime-support | python3-pil.imagetk,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3-olefile
Suggests: python-pil-doc, python3-pil-dbg
Provides: ${python:Provides}, python3-pillow
Conflicts: python3-imaging (<< 1.1.7+2.0.0-1.1)
Breaks: python3-imaging (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Python3)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 Image Objects:
  o Bilevel, greyscale, palette, true colour (RGB), true colour with
    transparency (RGBA).
  o colour separation (CMYK).
  o Copy, cut, paste operations.
  o Flip, transpose, resize, rotate, and arbitrary affine transforms.
  o Transparency operations.
  o Channel and point operations.
  o Colour transforms, including matrix operations.
  o Image enhancement, including convolution filters.
 .
 File Formats:
  o Full (Open/Load/Save): BMP, EPS (with ghostscript), GIF, IM, JPEG,
    MSP, PDF, PNG, PPM, TIFF, XBM.
  o Read only (Open/Load): ARG, CUR, DCX, FLI, FPX, GBR, GD, ICO, IMT, IPTC,
    MCIDAS, MPEG, PhotoCD, PCX, PIXAR, PSD, TGA, SGI, SUN, TGA, WMF, XPM.
  o Save only: PDF, EPS (without ghostscript).

Package: python3-pil-dbg
Section: debug
Priority: optional
Architecture: any
Multi-Arch: same
Depends: python3-pil (= ${binary:Version}), python3-dbg,
  ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-imaging-dbg (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-dbg (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Python3 debug extension)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python3-pil.imagetk
Architecture: any
Multi-Arch: same
Depends: python3-pil (= ${binary:Version}),
  python3-tk (>= 3.4.1-2),
  ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python-pil-doc, python3-pil.imagetk-dbg
Provides: ${python:Provides}
Breaks: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Python3)
 Tk dependent python-pil module.

Package: python3-pil.imagetk-dbg
Section: debug
Priority: optional
Architecture: any
Multi-Arch: same
Depends: python3-pil.imagetk (= ${binary:Version}),
  python3-pil-dbg (= ${binary:Version}),
  python3-dbg, ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Python3 debug extension)
 Tk dependent python-pil module.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python-pil-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python3-doc, python3-pil, python3-pil.imagetk
Description: Examples for the Python Imaging Library
 The Python Imaging Library (PIL) adds an image object to your
 Python interpreter. You can load image objects from a variety of file
 formats, and apply a rich set of image operations to them.
 .
 This package contains PIL API documentation and some example scripts.
 You may also want to look at the python-pil-doc-html or
 python-pil-doc-pdf packages for the PIL handbook documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PY3VERS	:= $(shell py3versions -vr)
PY3VER   := $(shell python3 -c 'import sys; print(sys.version[:3])')

include /usr/share/python3/python.mk

include /usr/share/dpkg/architecture.mk
ifneq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
  SET_CROSS_ENV = PYTHONPATH=/usr/lib/python$$pv/plat-$(DEB_HOST_MULTIARCH)

  # FIXME: is this sufficient?
  SET_CROSS_ENV += _PYTHON_HOST_PLATFORM=$(DEB_HOST_GNU_CPU)
endif

build-arch: BBB=bbb
build-indep: III=iii
build-arch: build
build-indep: build build-doc-stamp
build: build-stamp

build-doc-stamp: build
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
	PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
	touch $@

build-stamp: $(PY3VERS:%=build-stamp-python%) $(PY3VERS:%=check-stamp-python%)
	touch $@
build-stamp-python%:
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
#	tar xvf debian/lcms-images.tar.gz
	$(SET_CROSS_ENV) python$* setup.py build

	$(SET_CROSS_ENV) python$*-dbg setup.py build
	touch $@

pillow_tests = $(wildcard Tests/test*.py)

check-stamp-python%:
ifeq (0,1)
ifeq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
	: # run the tests for the debug interpreter, but continue in case of error
	rm -rf tmp
	mkdir -p tmp
	ln -s ../Tests tmp/Tests
	ln -s ../build tmp/build
ifeq (0,1)
	@echo BEGIN python$*-dbg tests
	-cd tmp && python$*-dbg ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
endif
	@echo BEGIN python$* tests
	-cd tmp && python$* ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
endif
endif
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp*
	rm -rf compile build
	rm -rf debian/PILcompat/build
	rm -rf Pillow*.egg-info
	find -name '*.py[co]' -exec rm -f {} \;
	find -type d -name __pycache__ | xargs -r rm -rf
#	rm -f $$(tar tf debian/lcms-images.tar.gz)
	rm -rf tmp
	rm -rf docs/_build
	dh_clean

get-doc:
	wget -r --no-parent --no-host-directories --cut-dirs=2 \
		http://www.pythonware.com/library/pil/handbook/index.htm

install: build install-prereq $(PY3VERS:%=install3-python%)
	dh_installdocs -ppython-pil-doc #Docs/*
	dh_installexamples -ppython-pil-doc

	dh_installdocs -ppython3-pil README.rst

	: # Replace all '#!' calls to python with /usr/bin/python
	: # and make them executable
	for i in `find debian/python3-pil* -mindepth 3 -type f`; do \
	  sed '1s,#!.*python[^ ]*\(.*\),#! /usr/bin/python3\1,' \
		$$i > $$i.temp; \
	  if cmp --quiet $$i $$i.temp; then \
	    rm -f $$i.temp; \
	  else \
	    mv -f $$i.temp $$i; \
	    chmod 755 $$i; \
	    echo "fixed interpreter: $$i"; \
	  fi; \
	done

install-prereq:
	dh_testdir
	dh_testroot
	dh_prep

install3-python%:
	$(SET_CROSS_ENV) python$* setup.py install \
		--root $(CURDIR)/debian/python3-pil \
		$(py_setup_install_args)

	incdir=$$(python$* -c 'import sysconfig; print(sysconfig.get_path("include"))'); \
	mkdir -p debian/python3-pil/$$incdir; \
	install -o root -g root -m 644 \
		src/libImaging/Imaging.h \
		src/libImaging/ImagingUtils.h \
		src/libImaging/ImPlatform.h \
		src/libImaging/ImDib.h \
		debian/python3-pil/$$incdir

	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
	then \
		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
	else \
		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))")-$(DEB_HOST_MULTIARCH); \
	fi; \
	echo $$abitag; \
	dh_movefiles -ppython3-pil.imagetk \
	    --sourcedir=debian/python3-pil \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/ImageTk.py

	$(SET_CROSS_ENV) python$*-dbg setup.py install \
		--root $(CURDIR)/debian/python3-pil-dbg \
		$(py_setup_install_args)

	incname=$$(basename $$(python$* -c 'import sysconfig; print(sysconfig.get_path("include"))')); \
	incddir=$$(python$*-dbg -c 'import sysconfig; print(sysconfig.get_path("include"))'); \
	mkdir -p debian/python3-pil-dbg/$$incddir; \
	for i in Imaging.h ImagingUtils.h ImPlatform.h ImDib.h; do \
	  ln -sf ../$$incname/$$i \
	    debian/python3-pil-dbg/$$incddir/$$i; \
	done

	find debian/python3-pil*-dbg \
		! -type d ! \( -name '*.so' -o -name '*.h' \) | xargs rm -f
	find debian/python3-pil*-dbg -depth -empty -exec rmdir {} \;

	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
	then \
		abitag=.$$(python$*-dbg -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
	else \
		abitag=.$$(python$*-dbg -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))")-$(DEB_HOST_MULTIARCH); \
	fi; \
	dh_movefiles -ppython3-pil.imagetk-dbg \
	    --sourcedir=debian/python3-pil-dbg \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build build-doc-stamp install
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installdocs -ppython-pil-doc docs/_build/html
	dh_sphinxdoc -ppython-pil-doc
	dh_installexamples -i
	dh_installchangelogs -i CHANGES.rst
	dh_python2 -i
	dh_link -i
	dh_compress -i -X.py
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installchangelogs -a CHANGES.rst
	for p in \
	  python3-pil python3-pil.imagetk; \
	do \
	  rm -rf debian/$$p-dbg/usr/share/doc/$$p-dbg; \
	  ln -s $$p debian/$$p-dbg/usr/share/doc/$$p-dbg; \
	done
	dh_python3 -a
	dh_strip -ppython3-pil --dbg-package=python3-pil-dbg
	dh_strip -ppython3-pil.imagetk --dbg-package=python3-pil.imagetk-dbg
	dh_link -a
	dh_compress -a -X.py
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/tests/control ===
Tests: selftest-py3
Depends: @

#Tests: upstream-py3
#Restrictions: allow-stderr
#Depends: @, webp, python3-pytest

## pillow 7.2.0

=== debian/changelog ===
pillow (7.2.0-1ubuntu0.3) groovy-security; urgency=medium

  * SECURITY UPDATE: OOB read in Jpeg2KDecode
    - debian/patches/CVE-2021-25287_8.patch: handle different widths for
      each band in src/libImaging/Jpeg2KDecode.c.
    - CVE-2021-25287
    - CVE-2021-25288
  * SECURITY UPDATE: DOS in PsdImagePlugin
    - debian/patches/CVE-2021-28675.patch: sanity check the number of
      input layers in Tests/test_decompression_bomb.py,
      Tests/test_file_apng.py, Tests/test_file_blp.py,
      Tests/test_file_tiff.py, src/PIL/ImageFile.py,
      src/PIL/PsdImagePlugin.py.
    - CVE-2021-28675
  * SECURITY UPDATE: FLI DOS
    - debian/patches/CVE-2021-28676.patch: check the block advance in
      src/libImaging/FliDecode.c.
    - CVE-2021-28676
  * SECURITY UPDATE: EPS DOS on _open
    - debian/patches/CVE-2021-28677.patch: properly handle line endings in
      src/PIL/EpsImagePlugin.py.
    - CVE-2021-28677
  * SECURITY UPDATE: BLP DOS
    - debian/patches/CVE-2021-28678.patch: check that reads return data in
      src/PIL/BlpImagePlugin.py.
    - CVE-2021-28678

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 18 May 2021 07:10:06 -0400

pillow (7.2.0-1ubuntu0.2) groovy-security; urgency=medium

  * SECURITY UPDATE: insufficient fix for CVE-2020-35654
    - debian/patches/CVE-2021-25289.patch: improve return code check in
      src/libImaging/TiffDecode.c.
    - CVE-2021-25289
  * SECURITY UPDATE: negative-offset memcpy with an invalid size
    - debian/patches/CVE-2021-25290.patch: add extra check to
      src/libImaging/TiffDecode.c.
    - CVE-2021-25290
  * SECURITY UPDATE: invalid tile boundaries could lead to an OOB Read
    - debian/patches/CVE-2021-25291.patch: check tile validity in
      src/libImaging/TiffDecode.c.
    - CVE-2021-25291
  * SECURITY UPDATE: DoS via backtrack regex
    - debian/patches/CVE-2021-25292.patch: use more specific regex in
      src/PIL/PdfParser.py.
    - CVE-2021-25292
  * SECURITY UPDATE: Out of Bounds Read
    - debian/patches/CVE-2021-25293.patch: add more checks to
      src/libImaging/SgiRleDecode.c.
    - CVE-2021-25293
  * SECURITY UPDATE: DoS via invalid reported size
    - debian/patches/CVE-2021-2792x.patch: check reported sizes in
      src/PIL/BlpImagePlugin.py, src/PIL/IcnsImagePlugin.py,
      src/PIL/IcoImagePlugin.py.
    - CVE-2021-27921
    - CVE-2021-27922
    - CVE-2021-27923

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 10 Mar 2021 12:41:13 -0500

pillow (7.2.0-1ubuntu0.1) groovy-security; urgency=medium

  * SECURITY UPDATE: buffer over-read via PCX file
    - debian/patches/CVE-2020-35653.patch: don't trust the image to specify
      a buffer size in src/PIL/PcxImagePlugin.py.
    - CVE-2020-35653
  * SECURITY UPDATE: heap overflow via YCbCr files
    - debian/patches/CVE-2020-35654-1.patch: fix tiff comparison warnings
      in src/libImaging/TiffDecode.c.
    - debian/patches/CVE-2020-35654-2.patch: fix OOB write in
      src/libImaging/TiffDecode.c.
    - debian/patches/CVE-2020-35654-3.patch: rework ReadTile in
      src/libImaging/TiffDecode.c.
    - CVE-2020-35654
  * SECURITY UPDATE: buffer over-read via SGI RLE image file
    - debian/patches/CVE-2020-35655-1.patch: add checks to
      src/libImaging/SgiRleDecode.c.
    - debian/patches/CVE-2020-35655-2.patch: rework error flags in
      src/libImaging/SgiRleDecode.c.
    - CVE-2020-35655

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 13 Jan 2021 09:35:02 -0500

pillow (7.2.0-1) unstable; urgency=medium

  * New upstream version.
  * Update debian/copyright, partially addresses #952899.
    - Mention contributors.
    - Add copyright information for fonts.
  * Bump debhelper version.

 -- Matthias Klose <doko@debian.org>  Thu, 16 Jul 2020 13:42:51 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
-Build-Depends: debhelper (>= 9), tk-dev, dpkg-dev (>= 1.16.1~),
+Build-Depends: debhelper (>= 10), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
   python2,
   python3-all-dev, python3-all-dbg, python3-setuptools,

## pillow 8.1.2

=== debian/changelog ===
pillow (8.1.2-1ubuntu0.2) hirsute-security; urgency=medium

  * SECURITY UPDATE: regular expression DoS
    - debian/patches/CVE-2021-23437.patch: raise ValueError if color
      specifier is too long in Tests/test_imagecolor.py,
      src/PIL/ImageColor.py.
    - CVE-2021-23437
  * SECURITY UPDATE: Dos via buffer overflow
    - debian/patches/CVE-2021-34552.patch: limit sprintf modes to 10
      characters in src/libImaging/Convert.c.
    - CVE-2021-34552
  * SECURITY UPDATE: improper initialization
    - debian/patches/CVE-2022-22815.patch: initialize coordinates to zero
      in Tests/test_imagepath.py, src/path.c.
    - CVE-2022-22815
  * SECURITY UPDATE: buffer over-read during initialization
    - debian/patches/CVE-2022-22816.patch: handle case where path count is
      zero in Tests/test_imagepath.py, src/path.c.
    - CVE-2022-22816
  * SECURITY UPDATE: evaluation of arbitrary expressions
    - debian/patches/CVE-2022-22817.patch: restrict builtins for
      ImageMath.eval in Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - CVE-2022-22817

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Jan 2022 12:54:47 -0500

pillow (8.1.2-1ubuntu0.1) hirsute-security; urgency=medium

  * SECURITY UPDATE: OOB read in Jpeg2KDecode
    - debian/patches/CVE-2021-25287_8.patch: handle different widths for
      each band in src/libImaging/Jpeg2KDecode.c.
    - CVE-2021-25287
    - CVE-2021-25288
  * SECURITY UPDATE: DOS in PsdImagePlugin
    - debian/patches/CVE-2021-28675.patch: sanity check the number of
      input layers in Tests/test_decompression_bomb.py,
      Tests/test_file_apng.py, Tests/test_file_blp.py,
      Tests/test_file_tiff.py, src/PIL/ImageFile.py,
      src/PIL/PsdImagePlugin.py.
    - CVE-2021-28675
  * SECURITY UPDATE: FLI DOS
    - debian/patches/CVE-2021-28676.patch: check the block advance in
      src/libImaging/FliDecode.c.
    - CVE-2021-28676
  * SECURITY UPDATE: EPS DOS on _open
    - debian/patches/CVE-2021-28677.patch: properly handle line endings in
      src/PIL/EpsImagePlugin.py.
    - CVE-2021-28677
  * SECURITY UPDATE: BLP DOS
    - debian/patches/CVE-2021-28678.patch: check that reads return data in
      src/PIL/BlpImagePlugin.py.
    - CVE-2021-28678

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 18 May 2021 07:09:08 -0400

pillow (8.1.2-1) unstable; urgency=high

  * New upstream version.
    - Fix Memory DOS in BLP (CVE-2021-27921), ICNS (CVE-2021-27922)
      and ICO (CVE-2021-27923) Image Plugins.

 -- Matthias Klose <doko@debian.org>  Tue, 09 Mar 2021 08:12:51 +0100

pillow (8.1.1-1) unstable; urgency=high

  * New upstream version.
    - Use more specific regex chars to prevent ReDoS. CVE-2021-25292.
    - Fix OOB Read in TiffDecode.c, and check the tile validity before reading.
      CVE-2021-25291.
    - Fix negative size read in TiffDecode.c. CVE-2021-25290.
    - Fix OOB read in SgiRleDecode.c. CVE-2021-25293.
    - Incorrect error code checking in TiffDecode.c. CVE-2021-25289.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Mar 2021 07:13:48 +0100

pillow (8.1.0-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards and debhelper versions.

 -- Matthias Klose <doko@debian.org>  Wed, 06 Jan 2021 13:18:02 +0100

pillow (8.0.1-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 29 Oct 2020 20:02:10 +0100

pillow (8.0.0-1) experimental; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 17 Oct 2020 12:09:16 +0200

## pillow 8.1.2%2Bdfsg

=== debian/changelog ===
pillow (8.1.2+dfsg-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Cherrypick security fixes from 8.2:
    - CVE-2021-25287 / CVE-2021-25288 / CVE-2021-28675 / CVE-2021-28676
      CVE-2021-28677 / CVE-2021-28678 (Closes: #989062)

 -- Moritz Muehlenhoff <jmm@debian.org>  Sun, 13 Jun 2021 18:11:04 +0200

pillow (8.1.2+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Repack for DFSG compliance and update d/copyright. Closes: #952899.
  * Update d/watch for +dfsg repack.

 -- Romain Porte <debian@microjoe.org>  Sat, 24 Apr 2021 15:51:24 +0200

## pillow 8.1.2+dfsg

=== Makefile ===
.DEFAULT_GOAL := help

.PHONY: clean
clean:
	python3.9 setup.py clean
	rm src/PIL/*.so || true
	rm -r build || true
	find . -name __pycache__ | xargs rm -r || true

.PHONY: coverage
coverage:
	pytest -qq
	rm -r htmlcov || true
	coverage report

.PHONY: doc
doc:
	$(MAKE) -C docs html

.PHONY: doccheck
doccheck:
	$(MAKE) -C docs html
# Don't make our tests rely on the links in the docs being up every single build.
# We don't control them.  But do check, and update them to the target of their redirects.
	$(MAKE) -C docs linkcheck || true

.PHONY: docserve
docserve:
	cd docs/_build/html && python3.9 -m http.server 2> /dev/null&

.PHONY: help
help:
	@echo "Welcome to Pillow development. Please use \`make <target>\` where <target> is one of"
	@echo "  clean              remove build products"
	@echo "  coverage           run coverage test (in progress)"
	@echo "  doc                make html docs"
	@echo "  docserve           run an http server on the docs directory"
	@echo "  html               to make standalone HTML files"
	@echo "  inplace            make inplace extension"
	@echo "  install            make and install"
	@echo "  install-coverage   make and install with C coverage"
	@echo "  install-req        install documentation and test dependencies"
	@echo "  install-venv       (deprecated) install in virtualenv"
	@echo "  lint               run the lint checks"
	@echo "  lint-fix           run black and isort to (mostly) fix lint issues."
	@echo "  release-test       run code and package tests before release"
	@echo "  test               run tests on installed pillow"
	@echo "  upload             build and upload sdists to PyPI"
	@echo "  upload-test        build and upload sdists to test.pythonpackages.com"

.PHONY: inplace
inplace: clean
	python3.9 setup.py develop build_ext --inplace

.PHONY: install
install:
	python3.9 setup.py install
	python3.9 selftest.py

.PHONY: install-coverage
install-coverage:
	CFLAGS="-coverage -Werror=implicit-function-declaration" python3.9 setup.py build_ext install
	python3.9 selftest.py

.PHONY: debug
debug:
# make a debug version if we don't have a -dbg python. Leaves in symbols
# for our stuff, kills optimization, and redirects to dev null so we
# see any build failures.
	make clean > /dev/null
	CFLAGS='-g -O0' python3.9 setup.py build_ext install > /dev/null

.PHONY: install-req
install-req:
	python3.9 -m pip install -r requirements.txt

.PHONY: install-venv
install-venv:
	echo "'install-venv' is deprecated and will be removed in a future Pillow release"
	virtualenv .
	bin/pip install -r requirements.txt

.PHONY: release-test
release-test:
	$(MAKE) install-req
	python3.9 setup.py develop
	python3.9 selftest.py
	python3.9 -m pytest Tests
	python3.9 setup.py install
	-rm dist/*.egg
	-rmdir dist
	python3.9 -m pytest -qq
	check-manifest
	pyroma .
	$(MAKE) readme

.PHONY: sdist
sdist:
	python3.9 setup.py sdist --format=gztar

.PHONY: test
test:
	pytest -qq

.PHONY: readme
readme:
	python3.9 setup.py --long-description | markdown2 > .long-description.html && open .long-description.html


.PHONY: lint
lint:
	tox --help > /dev/null || python3.9 -m pip install tox
	tox -e lint

.PHONY: lint-fix
lint-fix:
	black --target-version py36 .
	isort .

=== requirements.txt ===
# Development, documentation & testing requirements.
black
check-manifest
coverage
markdown2
olefile
packaging
pyroma
pytest
pytest-cov
sphinx>=2.4
sphinx-issues
sphinx-removed-in
sphinx-rtd-theme

=== docs/Makefile ===
--- 
+++ 
@@ -142,7 +142,7 @@
 	@echo "The overview file is in $(BUILDDIR)/changes."
 
 linkcheck:
-	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
+	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck -j auto
 	@echo
 	@echo "Link check complete; look for any errors in the above output " \
 	      "or in $(BUILDDIR)/linkcheck/output.txt."
@@ -156,4 +156,4 @@
 	livereload $(BUILDDIR)/html -p 33233
 
 serve:
-	cd $(BUILDDIR)/html; python -m SimpleHTTPServer
+	cd $(BUILDDIR)/html; python3 -m http.server

=== debian/changelog ===
pillow (8.1.2+dfsg-0.3+deb11u2) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Backport follow-up fix for CVE-2022-22817, upstream commit c930be075.
  * Backport fixes for CVE-2023-44271, CVE-2023-50447, CVE-2024-28219.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 02 Jun 2024 16:59:20 +0100

pillow (8.1.2+dfsg-0.3+deb11u1) bullseye-security; urgency=medium

  * CVE-2022-22815 CVE-2022-22816 CVE-2022-22817

 -- Moritz Mühlenhoff <jmm@debian.org>  Fri, 14 Jan 2022 16:44:08 +0100

pillow (8.1.2+dfsg-0.3) unstable; urgency=high

  * Non-maintainer upload by the Security Team.
  * Fix "CVE-2021-34552 - buffer overflow in Convert.c. Replace sprintf with
    snprintf. Backport upstream change from 8.3 to 8.1. (Closes: #991293)

 -- Neil Williams <codehelp@debian.org>  Tue, 20 Jul 2021 06:42:31 +0100

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 
 build-doc-stamp: build
 	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
-	PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
+	-PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
 	touch $@
 
 build-stamp: $(PY3VERS:%=build-stamp-python%) $(PY3VERS:%=check-stamp-python%)
@@ -79,7 +79,7 @@
 	dh_installdocs -ppython-pil-doc #Docs/*
 	dh_installexamples -ppython-pil-doc
 
-	dh_installdocs -ppython3-pil README.rst
+	dh_installdocs -ppython3-pil README.md
 
 	: # Replace all '#!' calls to python with /usr/bin/python
 	: # and make them executable

=== debian/watch ===
version=3
opts="oversionmangle=s/(.*)/$1+dfsg/, dversionmangle=s/\+dfsg\d*$//" \
http://pypi.debian.net/Pillow/Pillow-(.*)\.(?:tar\.gz|zip)

## pillow 8.3.2

=== requirements.txt ===
--- 
+++ 
@@ -2,13 +2,17 @@
 black
 check-manifest
 coverage
+defusedxml
 markdown2
 olefile
 packaging
 pyroma
 pytest
 pytest-cov
+pytest-timeout
 sphinx>=2.4
+sphinx-copybutton
 sphinx-issues
 sphinx-removed-in
 sphinx-rtd-theme
+sphinxext-opengraph

=== debian/changelog ===
pillow (8.3.2-1~mx21) mx; urgency=medium

  * Rebuild for MX-21 Test repo

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 04 Jul 2023 13:05:42 -0400

pillow (8.3.2-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Mon, 11 Oct 2021 15:35:03 +0200

pillow (8.2.0-1) experimental; urgency=medium

  * New upstream version.
  * Build-depend on libopenjp2-7-dev. Closes: #904478.

 -- Matthias Klose <doko@debian.org>  Thu, 15 Apr 2021 11:37:53 +0200

pillow (8.1.2+dfsg-1) unstable; urgency=medium

  * Stop building the python3-*-dbg packages. Closes: #994317.

 -- Matthias Klose <doko@debian.org>  Wed, 15 Sep 2021 14:16:02 +0200

=== debian/control ===
Source: pillow
Section: python
Priority: optional
Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 11), tk-dev, dpkg-dev (>= 1.16.1~),
  dh-python,
  python2,
  python3-all-dev, python3-setuptools,
  python3-tk,
  python3-pytest,
  python3-olefile,
  python3-cffi,
  libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
  libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
  libimagequant-dev,
  libopenjp2-7-dev,
Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
  python3-sphinx-issues, python3-sphinx-copybutton,
Standards-Version: 4.6.0
Homepage: http://python-pillow.github.io/
XS-Testsuite: autopkgtest

Package: python3-pil
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, mime-support | python3-pil.imagetk,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3-olefile
Suggests: python-pil-doc
Provides: ${python:Provides}, python3-pillow
Conflicts: python3-imaging (<< 1.1.7+2.0.0-1.1)
Breaks: python3-imaging (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Python3)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 Image Objects:
  o Bilevel, greyscale, palette, true colour (RGB), true colour with
    transparency (RGBA).
  o colour separation (CMYK).
  o Copy, cut, paste operations.
  o Flip, transpose, resize, rotate, and arbitrary affine transforms.
  o Transparency operations.
  o Channel and point operations.
  o Colour transforms, including matrix operations.
  o Image enhancement, including convolution filters.
 .
 File Formats:
  o Full (Open/Load/Save): BMP, EPS (with ghostscript), GIF, IM, JPEG,
    MSP, PDF, PNG, PPM, TIFF, XBM.
  o Read only (Open/Load): ARG, CUR, DCX, FLI, FPX, GBR, GD, ICO, IMT, IPTC,
    MCIDAS, MPEG, PhotoCD, PCX, PIXAR, PSD, TGA, SGI, SUN, TGA, WMF, XPM.
  o Save only: PDF, EPS (without ghostscript).

Package: python3-pil.imagetk
Architecture: any
Multi-Arch: same
Depends: python3-pil (= ${binary:Version}),
  python3-tk (>= 3.4.1-2),
  ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python-pil-doc
Provides: ${python:Provides}
Breaks: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Python3)
 Tk dependent python-pil module.

Package: python-pil-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python3-doc, python3-pil, python3-pil.imagetk
Description: Examples for the Python Imaging Library
 The Python Imaging Library (PIL) adds an image object to your
 Python interpreter. You can load image objects from a variety of file
 formats, and apply a rich set of image operations to them.
 .
 This package contains PIL API documentation and some example scripts.
 You may also want to look at the python-pil-doc-html or
 python-pil-doc-pdf packages for the PIL handbook documentation.

=== debian/rules ===
--- 
+++ 
@@ -33,8 +33,6 @@
 	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 #	tar xvf debian/lcms-images.tar.gz
 	$(SET_CROSS_ENV) python$* setup.py build
-
-	$(SET_CROSS_ENV) python$*-dbg setup.py build
 	touch $@
 
 pillow_tests = $(wildcard Tests/test*.py)
@@ -42,15 +40,10 @@
 check-stamp-python%:
 ifeq (0,1)
 ifeq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
-	: # run the tests for the debug interpreter, but continue in case of error
 	rm -rf tmp
 	mkdir -p tmp
 	ln -s ../Tests tmp/Tests
 	ln -s ../build tmp/build
-ifeq (0,1)
-	@echo BEGIN python$*-dbg tests
-	-cd tmp && python$*-dbg ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
-endif
 	@echo BEGIN python$* tests
 	-cd tmp && python$* ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
 endif
@@ -126,32 +119,6 @@
 		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so \
 		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/ImageTk.py
 
-	$(SET_CROSS_ENV) python$*-dbg setup.py install \
-		--root $(CURDIR)/debian/python3-pil-dbg \
-		$(py_setup_install_args)
-
-	incname=$$(basename $$(python$* -c 'import sysconfig; print(sysconfig.get_path("include"))')); \
-	incddir=$$(python$*-dbg -c 'import sysconfig; print(sysconfig.get_path("include"))'); \
-	mkdir -p debian/python3-pil-dbg/$$incddir; \
-	for i in Imaging.h ImagingUtils.h ImPlatform.h ImDib.h; do \
-	  ln -sf ../$$incname/$$i \
-	    debian/python3-pil-dbg/$$incddir/$$i; \
-	done
-
-	find debian/python3-pil*-dbg \
-		! -type d ! \( -name '*.so' -o -name '*.h' \) | xargs rm -f
-	find debian/python3-pil*-dbg -depth -empty -exec rmdir {} \;
-
-	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
-	then \
-		abitag=.$$(python$*-dbg -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
-	else \
-		abitag=.$$(python$*-dbg -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))")-$(DEB_HOST_MULTIARCH); \
-	fi; \
-	dh_movefiles -ppython3-pil.imagetk-dbg \
-	    --sourcedir=debian/python3-pil-dbg \
-		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so
-
 # Build architecture-independent files here.
 # Pass -i to all debhelper commands in this target to reduce clutter.
 binary-indep: build build-doc-stamp install
@@ -180,15 +147,8 @@
 	dh_installdocs -a
 	dh_installexamples -a
 	dh_installchangelogs -a CHANGES.rst
-	for p in \
-	  python3-pil python3-pil.imagetk; \
-	do \
-	  rm -rf debian/$$p-dbg/usr/share/doc/$$p-dbg; \
-	  ln -s $$p debian/$$p-dbg/usr/share/doc/$$p-dbg; \
-	done
 	dh_python3 -a
-	dh_strip -ppython3-pil --dbg-package=python3-pil-dbg
-	dh_strip -ppython3-pil.imagetk --dbg-package=python3-pil.imagetk-dbg
+	dh_strip -a
 	dh_link -a
 	dh_compress -a -X.py
 	dh_fixperms -a
